/* --------------------------------------------------------
 Generated by Gunandi using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Gunandi (andri.gunandi1@gmail.com) 
 Date Created : 21/05/2019
 --------------------------------------------------------
*/
package com.portofolio.controller;

import  java.util.Map;

import  javax.servlet.http.HttpServletRequest;
import  javax.validation.Valid;

import  org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import  org.springframework.web.bind.annotation.DeleteMapping;
import  org.springframework.web.bind.annotation.GetMapping;
import  org.springframework.web.bind.annotation.PostMapping;
import  org.springframework.web.bind.annotation.PutMapping;
import  org.springframework.web.bind.annotation.RequestBody;
import  org.springframework.web.bind.annotation.RequestMapping;
import  org.springframework.web.bind.annotation.RequestParam;
import  org.springframework.web.bind.annotation.RestController;

import com.portofolio.base.LocaleController;
import com.portofolio.dto.ProfileConfigDesignDto;
import com.portofolio.service.ProfileConfigDesignService;
import com.portofolio.util.RestUtil;

import  io.swagger.annotations.ApiOperation;


@SuppressWarnings("rawtypes")
@RestController
@RequestMapping("/profileConfigDesign")
public class ProfileConfigDesignController extends LocaleController {
    @Autowired
    private ProfileConfigDesignService profileConfigDesignService;
    
   
    @ApiOperation("Api Untuk Menyimpan ProfileConfigDesign")
    @PostMapping("/save")
    public  ResponseEntity<Map<String, Object>> save(@Valid @RequestBody ProfileConfigDesignDto entity,HttpServletRequest request) {
        Map<String, Object> result = profileConfigDesignService.save(entity);
        return RestUtil.getJsonResponse(result);
    }
   
    @ApiOperation("Api Untuk Update ProfileConfigDesign")
    @PutMapping("/update")
    public ResponseEntity<Map<String, Object>> update(
    		@RequestParam(value = "version", required = true) Integer version,	
    		@Valid @RequestBody ProfileConfigDesignDto entity, HttpServletRequest request) {
        Map<String, Object> result = profileConfigDesignService.update(entity,version);
        return RestUtil.getJsonResponse(result);
    }
    
   
    @ApiOperation("Api Untuk Menghapus ProfileConfigDesign BerdasarkanKdProfileConfigDesign")
    @DeleteMapping("/delete")
    public ResponseEntity<Map<String, Object>> deleteById(
    		@RequestParam(value = "kdModulAplikasi", required = true) String kdModulAplikasi,	
    		@RequestParam(value = "kdVersion", required = true) Integer kdVersion,	
    		@RequestParam(value = "kdProfile", required = true) Integer kdProfile,
    		@RequestParam(value = "version", required = true) Integer version
    		) {
        Map<String, Object> result = profileConfigDesignService.deleteById(kdModulAplikasi, kdVersion, kdProfile, version);
        return RestUtil.getJsonResponse(result);
    }
    
   
    @ApiOperation("Api Untuk Menampilkan Semua ProfileConfigDesign")
    @GetMapping("/grid")
    public ResponseEntity<Map<String, Object>> grid(			
    		@RequestParam(value = "page", defaultValue = "1") Integer page,			
    		@RequestParam(value = "rows", defaultValue = stringAsIntegerMaxValue) Integer rows,			
    		@RequestParam(value = "dir", defaultValue = "modulAplikasi.namaModulAplikasi") String dir,			
    		@RequestParam(value = "sort", defaultValue = "desc") String sort,			
    		@RequestParam(value = "namaModulAplikasi", defaultValue = "", required = false) String namaModulAplikasi,
    		@RequestParam(value = "statusEnabled", required = true) boolean statusEnabled) {
        Map<String, Object> result = profileConfigDesignService.grid(page, rows, sort, dir, namaModulAplikasi,statusEnabled);
        return RestUtil.getJsonResponse(result);
    }
    
   
    @ApiOperation("Api Untuk Menampilkan ProfileConfigDesign Berdasarkan kode")
    @GetMapping("/findById")
    public ResponseEntity<Map<String, Object>> findByKode(
    		@RequestParam(value = "kdModulAplikasi", required = true) String kdModulAplikasi,	
    		@RequestParam(value = "kdVersion", required = true) Integer kdVersion,	
    		@RequestParam(value = "kdProfile", required = true) Integer kdProfile
    		) {
        Map<String, Object> result = profileConfigDesignService.findById(kdModulAplikasi, kdVersion, kdProfile);
        return RestUtil.getJsonResponse(result);
    }
    


}
